package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.User;
import org.vtokarev.service.UserService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Optional;

/**
 * The {@code LoginServlet} uses for login users.
 * The class implements {@code doGet} method that processes GET {@code imageList} requests generated by users with ADMIN role.
 * {@code doGet} method forward control to {@code login.jsp} view for further processing.
 * {@code doPost} method uses the collected data and implements user authentication and authorization.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/login", name = "loginServlet")
public class LoginServlet extends HttpServlet {

    private static final Logger LOGGER = LogManager.getLogger(LoginServlet.class);
    private UserService userService;


    @Override
    public void init(ServletConfig config) throws ServletException {
        userService = (UserService)config.getServletContext().getAttribute("app/UserService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        req.getRequestDispatcher("/WEB-INF/jsp/login.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {

        String email = req.getParameter("email");
        String password = req.getParameter("password");

        Optional<User> user = userService.getUserByEmail(email);
        HttpSession session = req.getSession();

        if(user.isPresent() && userService.isValid(user.get(), password)){
            session.setAttribute("user", user.get());
            LOGGER.info("Success login {}", email);
            resp.sendRedirect("home");
        } else {
            req.setAttribute("invalidCredentials", true);
            LOGGER.info("Failed login {}", email);
            resp.sendRedirect("login?invalidCredentials=yes");
        }
    }
}
